/*******************************************************/
/*------------------ ANIME.H --------------------------*/
/* Header du module d'animation du Project FRACTAL.PRJ */
/*******************************************************/
extern OBJECT            *adr_form_canim ; /* Formulaire de calcul de squence   */
extern STATUS_ANIMATION  stat_anim ;       /* Paramtres de l'animation          */
extern ANIMATION_FRACTAL info_sequence ;   /* Donnes sur la squence en mmoire */
extern ANIMATION_FRACTAL ani_calc ;        /* Squence  calculer                */
extern OBJECT            *adr_form_canim ; /* Formulaire de calcul de squence   */
extern MFDB              virtuel ;         /* Pour l'animation depuis le disque  */
extern int               w_ani_handle ;    /* Handle de la fentre animation     */
extern int               flag_ani ;        /* Pour affiche_progression_calcul()  */


/********************************************/
/* Initialise les structures stat_anim, IMG */
/* Et les variables w_ani_handle, name_ani  */
/********************************************/
void init_module_anime(void) ;

/**************************************/
/* Libre la mmoire propre au module */
/**************************************/
void quitte_module_anime(void) ;

/******************************************************/
/* Libre la mmoire occupe par la squence d'images */
/******************************************************/
void libere_sequence(void) ;

/*************************************************************/
/* Charge en mmoire la squence d'animation point par name */
/* En retour : 0 : OK, la squence est  prsent en mmoire  */
/*             1 : Le fichier spcifi n'existe pas          */
/*************************************************************/
int charge_animation(char *name) ;

/*********************************************/
/* Affiche la boite de dialogue informations */
/* De la squence d'images  cacule.         */
/*********************************************/
int create_animation(ANIMATION_FRACTAL *data) ;

/************************************************************/
/* Lancement de l'animation                                 */
/*  0 : L'animation s'est bien droule.                    */
/* -1 : La fentre animation n'est pas entirement visible. */
/* -2 : Mmoire insuffisante.                               */
/************************************************************/
int animate(void) ;

/*****************************************************************/
/* Vrifie la cohrence des paramtres pour calculer l'animation */
/* 1 : Les images extrmes ne sont pas identiques                */
/* 2 : Les types des fractals sont les mmes                     */
/* 3 : Les algorithmes de calcul sont les mmes                  */
/*****************************************************************/
int ok_animate_parameters(FRACTAL *fs, FRACTAL *fe) ;

/**********************************/
/* Lance le calcul de l'animation */
/**********************************/
int calcule_animation(void) ;
